----------------------------------------------------------------------------------
-- Company: University of Ljubljana, Faculty of Electrical Engineering
-- Engineer: Andrej Trost
-- 
-- Create Date: 03/10/2015 01:15:47 PM
-- Design Name: Red Pitaya Graphics
-- Module Name: red_pitaya_graph
-- Project Name: http://www.redpitaya.com
-- Description: 
-- 
-- Revision: 1
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity red_pitaya_graf is
    Port ( clk50 : in STD_LOGIC; -- VGA signals
           hsync : out STD_LOGIC;
           vsync : out STD_LOGIC;
           rgb   : out STD_LOGIC_VECTOR (2 downto 0);
                      
           led : out STD_LOGIC_VECTOR (3 downto 0);

           -- System bus
           clk_i:   in STD_LOGIC;                      -- bus clock 
           rstn_i:  in STD_LOGIC;                      -- bus reset - active low
           adr_i:   in STD_LOGIC_VECTOR(31 downto 0);  -- bus address
           wdata_i: in STD_LOGIC_VECTOR(31 downto 0);  -- bus write data          
           wen_i:   in STD_LOGIC;                      -- bus write enable
           rdata_o: out STD_LOGIC_VECTOR(31 downto 0); -- bus read data
           err_o:   out STD_LOGIC;                     -- bus error indicator
           ack_o:   out STD_LOGIC                      -- bus acknowledge signal         
           );
end red_pitaya_graf;

architecture Behavioral of red_pitaya_graf is

 -- osnovna VGA komponenta
 component VGA is
     Port ( clk50 : in STD_LOGIC;
        hsync : out STD_LOGIC;
        vsync : out STD_LOGIC;
        rgb : out STD_LOGIC_VECTOR (2 downto 0);
        cx : out unsigned (9 downto 0);
        cy : out unsigned (9 downto 0);
        en : out STD_LOGIC
	 );
 end component;

begin

-- povezave
u0: VGA port map (
 clk50 => clk50,
 hsync => hsync,
 vsync => vsync,
 rgb => rgb,
 cx => open,
 cy => open,
 en => open
 );

led <= "1010";

-- izhodni signali sistemskega vodila
err_o <= '0';
rdata_o <= (others=>'0'); ack_o <= '1';

end Behavioral;
