----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 05/19/2015 04:14:03 PM
-- Design Name: 
-- Module Name: GeneratorSlike - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VGA is
    Port ( clk50 : in STD_LOGIC;
           hsync : out STD_LOGIC;
           vsync : out STD_LOGIC;
           rgb : out STD_LOGIC_VECTOR (2 downto 0);
           cx : out unsigned (9 downto 0);
           cy : out unsigned (9 downto 0);
           en : out STD_LOGIC);
end VGA;

architecture Behavioral of VGA is
signal hst: unsigned(11 downto 0):=(others=>'0');
signal vst: unsigned(10 downto 0):=(others=>'0');
signal cik: unsigned(2 downto 0):=(others=>'0');
constant H: integer := 1040;
constant Hp: integer := 800;
constant Hf: integer := 856;
constant Hs: integer := 120;
constant V: integer := 666;
constant Vp: integer := 600;
constant Vf: integer := 637;
constant Vs: integer := 6;
signal sync: std_logic;
signal oddeven: std_logic := '0';
begin

p: process (clk50)
begin
 if rising_edge(clk50) then
    
    if hst < H - 1 then
        hst <= hst + 1;
    else
        hst <= (others=>'0');
        cik <= cik + 1;
        if vst < V - 1 then
            vst <= vst + 1;
        else
            vst <= (others=>'0');
            oddeven <= not oddeven;
        end if;
    end if;
    
    cx <= hst(9 downto 0);
    cy <= vst(9 downto 0);

    if (vst < Vp and hst < Hp) then        
        en <= '1';
    else
        en <= '0';
    end if;
    
    if hst >= Hf and hst < Hf + Hs then
      sync <= '1';
    else
      sync <= '0';
    end if;
       
--    sck <= sync;
        
    if vst >= Vf and vst < Vf + Vs then
      vsync <= '1';
    else
      vsync <= '0';
    end if;
    
--    if cik=0 and hst>=600 and hst<700 then 
--      ldcp <= '0';
--    else
--      ldcp <= '1';
--    end if;
    
 end if;
end process;

hsync <= sync;
rgb <= "010" when hst<800 and vst<600 else "000";
--oe <= oddeven;
--hsync <= '1' when hst >= Hf and hst < Hf + Hs else '0';
--vsync <= '1' when vst >= Vf and vst < Vf + Vs else '0';

--ldcp <= '0' when cik=0 and hst>=600 and hst<700 else '1';

end Behavioral;
